// TCS3471 - Version: Latest 
#include <TCS3471.h>
/*************************************************
 * Public Constants
 *************************************************/

#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978

/*
  TCS3471.h - TCS3471 Color light-to-digital converter IC by TAOS/AMS library demo code
  Copyright (c) 2012, 2013 Raivis Rengelis (raivis [at] rrkb.lv). All rights reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 3 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <Wire.h>
#include <TCS3471.h>

// Since library stays away from hardware, user sketch has to take care about
// actual communications. Please note that functions need to be exactly like this,
// return void and accept 3 parameters, 1st - i2c address of slave chip,
// 2nd number of bytes to be written or read and 3rd - pointer to a byte array
// from where to read or where to write respective bytes
// Since TCS3471 chips have 12c fixed address, this can come in handy if you want to
// put multiple chips behind multiplexer or do something like that
void i2cWrite(byte address, byte count, byte* buffer);
void i2cRead(byte address, byte count, byte* buffer);

int RGB(float c,float red,float green,float blue);
char* colors[]={"yellow","magenta","Darkblue","red","skyblue","pink","orange","violet","green","darkgreen"};

// This is where TCS3471 object gets created
// See how functions declared get passed to constructor as parameters
TCS3471 TCS3471(i2cWrite, i2cRead);

// Just a variable to tell main loop that interrupt was triggered
volatile bool colorAvailable = false;

// counter to check when to finish printing
int printXtimes = 0;
const int threshold = 10;    // minimum reading of the sensors that generates a note
bool check_sensor(int i,int color);
// notes to play, corresponding to the 3 sensors:
int notes[] = {NOTE_C1,NOTE_D1,NOTE_E1,NOTE_F1,NOTE_G1, NOTE_A1}
int colors[]={1,2,3,4,5};
char* finger[]={"R_Thumb","R_IndexFinger","R_MiddleFinger","R_RingFinger","R_Pinky"};


void setup()
{
  Serial.print("Made it to setup!");
  
    Serial.begin(9600);
    // starting i2c interface in master mode
    Wire.begin();
    // TCS3471 can generate interrupt when color/light detection cycle finishes and/or is over or under set threshold
    // To free resources of Arduino connect INT pin of TCS3471 to pin 2 of Arduino and use interrupts!
    // NB! Open drain logic in use, which means high voltage = 0, low voltage = 1, thus FALLING edge trigger
    
    
    attachInterrupt(0,TCS3471Int,FALLING);
    // No need to pound the chip if there is no chip, detect() function checks if chip responds and returns true
    // if it is and false if it does not
    
       
    if(!TCS3471.detect())
        {
            Serial.println("Something is not right. Check your wiring, sensor needs at least VCC, GND, SCL and SDA.");
            while (1);
        }
    // tell TCS3471 to generate interrupts on INT pin
    TCS3471.enableInterrupt();
    // integration time is time chip takes to measure RGBC values, the longer, the higher precision
    // range is from 2.4ms up to 614.4ms, parameter is float and in milliseconds,
    // step is 2.4ms, but you can put in any number you like, library will take care of rounding
    TCS3471.setIntegrationTime(800.0);
    // set wait time between measurements, chip just sits there and waits for approximately that many
    // milliseconds and conserves power
    // range is from 2.4ms up to 7400ms, from 2.4ms up to 614.4ms step is 2.4ms, from 614.4ms up step is  28.8ms
    // library takes care of rounding in this case too
    // if set to anything less than 2.4ms, wait time is disabled
    //delay(1000);
    TCS3471.setWaitTime(6000.0);
    // chip has 4 different analog gain settings - TCS3471_GAIN_1X, TCS3471_GAIN_4X, TCS3471_GAIN_16X and TCS3471_GAIN_60X
    // naked chip under regular ambient lighting works ok with 1x gain
    TCS3471.setGain(TCS3471_GAIN_1X);
    // if C(lear) channel goes above this value, interrupt will be generated
    // range is from 0-65535, 16 full bits
    // just for demonstration purposes, setting it right above half of full range
    //TCS3471.interruptHighThreshold(32768);
    // similar as above, only C channel has to go below this value
    // again, range is from 0-65535
    // setting it right below half of full range
    // this will ensure that interrupt is generated all the time
    //TCS3471.interruptLowThreshold(32767);
    // interrupt persistence determines how many times in row C channel has to go above high threshold
    // or below low threshold for interrupt to be generated
    // range is from 1 to 60, from 1-3 step is 1, from 5-60 step is 5
    // library takes care of finding closest valid value
    TCS3471.interruptPersistence(2);
    // once interrupt flag is set in chip, it must be cleared from host
    // in case it was left on from previous runs, we clear it here
    // otherwise we are not going to get new interrupts
    TCS3471.clearInterrupt();
    // and finally, when all the parameters are set, let's start measuring color and light
    TCS3471.enable();
}

void loop()
{
    
  
    if (colorAvailable)
    {
      
      //Serial.print("okay");
      
    	// check if valid RGBC data is available
    	// in this scenario this call is redundant
    	// but for demonstration purposes, let's have it here
    	if (TCS3471.rgbcValid())
    	{
    		// as mentioned previously, interrupt flag has to be cleared from host
    		TCS3471.clearInterrupt();
    		// reset Arduino flag too
    		colorAvailable = false;
    		// read C(lear) channel data
    		// range from 0-65535
        	word clearVal = TCS3471.readCData();
        	// read R(ed) channel data
        	// range 0-65535
        	float c=clearVal;
        	word redVal   = TCS3471.readRData();
        	// read G(reen) channel data
        	// range 0-65535
        	float r=(redVal);
        	//r=r-498+255;
        	//Serial.print(redVal);
        	word greenVal = TCS3471.readGData();
        	float g=(greenVal);
        	//Serial.print(greenVal);
        	//g=g-242+255;
        	// read B(lue) channel data
        	// range 0-65535
        	
        	word blueVal  = TCS3471.readBData();
        	//Serial.print(blueVal);
        	float b=(blueVal);
        	//b=b-188+255;
        	// and print it all out
        	float avg=(c+r+g+b)/4;

        	r=r/avg;
        	b=b/avg;
        	g=g/avg;
        	Serial.print("Light is ");
        	Serial.print(clearVal,DEC);
        	Serial.print(" overall and red is ");
        	Serial.print(r, DEC);
        	Serial.print(" while green is ");
        	Serial.print(g, DEC);
        	Serial.print(" and blue is ");
        	Serial.println(b, DEC);
        	int x=RGB(c,r,g,b);
        	if(c<1000)
        	{
          	if ((x>0) &(x<6)){
          	tone(8, notes[x], 20);
        	  }
        	  
        	}
        	Serial.print(colors[x]);
        	Serial.println("");
        }
    }
    delay(500);
}

// this is function that gets called on interrupt from TCS3471
void TCS3471Int()
{
	colorAvailable = true;
}

bool check_sensor(int i,int color)
{
  int detected=RGB(red[i],green[i],blue[i]);
  if (detected==color)
    {return true;}
  return false;
}
colors[]={"yellow","magenta","Darkblue","red","skyblue","pink","orange","violet","green","darkgreen"};


int RGB(float c,float red,float green,float blue){
  if (c<1000){
  if ((red>1.4) & (red<1.55) & (green>0.33) & (green<0.35) & (blue>0.41) & (blue<0.44))
  {return 1;}
  
  else if ((red>0.86) & (red<1.0) & (green>0.43) & (green<0.56) & (blue>0.65) & (blue<1))
  {return 2;}
  
  else if ((red>1.60) & (red<1.66) & (green>0.23) & (green<0.25) & (blue>0.31) & (blue<0.34))
  {return 3;}
  
  else if ((red>1.07) & (red<1.10) & (green>0.50) & (green<0.61) & (blue>0.43) & (blue<0.46))
  {return 4;}
  
  else if ((red>1.59) & (red<1.65) & (green>0.23) & (green<0.26) & (blue>0.335) & (blue<0.359))
  {return 5;}
  
  else if ((red>1.62) & (red<1.68) & (green>0.20) & (green<0.23) & (blue>0.26) & (blue<0.28))
  {return 6;}
 
  else if ((red>1.20) & (red<1.23) & (green>0.48) & (green<0.53) & (blue>0.5) & (blue<0.8))
  {return 7;}
  
  else if ((red>1.20) & (red<1.22) & (green>0.53) & (green<0.55) & (blue>0.31) & (blue<0.35))
  {return 8;}
  
  else if ((red>1.15) & (red<1.20) & (green>0.4) & (green<0.55) & (blue>0.31) & (blue<0.35))
  {return 9;}
  
  }
  else 
    {return 0;}
  
  
}

// implementation of i2cWrite and i2cRead functions for simplest 
//case when there is only one
// TCS2471 chip attached to Arduino's two wire bus
void i2cWrite(byte address, byte count, byte* buffer)
{
    Wire.beginTransmission(address);
    byte i;
    for (i = 0; i < count; i++)
    {
#if ARDUINO >= 100
        Wire.write(buffer[i]);
#else
        Wire.send(buffer[i]);
#endif
    }
    Wire.endTransmission();
}

void i2cRead(byte address, byte count, byte* buffer)
{
    Wire.requestFrom(address, count);
    byte i;
    for (i = 0; i < count; i++)
    {
#if ARDUINO >= 100
        buffer[i] = Wire.read();
#else
        buffer[i] = Wire.receive();
#endif
    }
}
void play_sound(color){
 int sensorReading = analogRead(thisSensor);
      tone(8, notes[color], 20);
    }
}
