#include <TCS3471.h>
#include <Wire.h>

#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978

#define TCAADDR 0x70

float c;
float r;
float g;
float b;

int select=0;
int song_key=0;
int notes[] = {NOTE_C4,NOTE_D4,NOTE_E1,NOTE_F1,NOTE_G1, NOTE_A1};
int colors[]={1,2,3,4,5};
char* colorcode[]={"sky blue","violet","pink","green","magenta"};
char* finger[]={"R_Thumb","R_IndexFinger","R_MiddleFinger","R_RingFinger","R_Pinky"};

void i2cWrite(byte address, byte count, byte* buffer);
void i2cRead(byte address, byte count, byte* buffer);
bool RGB(float c,float red,float green,float blue);

volatile bool colorAvailable[8] = {false,false,false,false,false,false,false,false};
bool select_available=true;

TCS3471 sensor(i2cWrite, i2cRead), sensor1(i2cWrite, i2cRead),sensor2(i2cWrite, i2cRead),sensor3(i2cWrite, i2cRead),sensor4(i2cWrite, i2cRead),sensor5(i2cWrite, i2cRead),sensor6(i2cWrite, i2cRead),sensor7(i2cWrite, i2cRead),sensor8(i2cWrite, i2cRead),sensor9(i2cWrite, i2cRead),sensor10(i2cWrite, i2cRead),sensor11(i2cWrite, i2cRead);
TCS3471 sensors[8]={sensor, sensor1,sensor2,sensor3,sensor4,sensor5,sensor6,sensor7};

byte controlPins[] = {B00000000, 
                  B10000000,
                  B01000000,
                  B11000000,
                  B00100000,
                  B10100000,
                  B01100000,
                  B11100000,
                  B00010000,
                  B10010000,
                  B01010000,
                  B11010000,
                  B00110000,
                  B10110000,
                  B01110000,
                  B11110000 }; 
 
// holds incoming values from 74HC4067                  

float green[8]={0,0,0,0,0,0,0,0};
float blue[8]={0,0,0,0,0,0,0,0};
float red[8]={0,0,0,0,0,0,0,0};
float clear[8]={0,0,0,0,0,0,0,0};

void tcaselect(uint8_t i) {
  if (i > 7) return;
 
  Wire.beginTransmission(TCAADDR);
  Wire.write(1 << i);
  Wire.endTransmission();  
}
 

//print("ok _start");
void setup()
{
  
  Serial.begin(9600);
  
  Wire.begin();
  Serial.println("ok");
  
  for(int i=0; i<5;i++)
  {
    //Serial.println(i);
    tcaselect(i);
    attachInterrupt(0,TCS3471Int,FALLING);
    
    if(!sensors[i].detect())
        {
            Serial.println("Something is not right. Check your wiring, sensor needs at least VCC, GND, SCL and SDA.");
            while (1);
        }
       
    sensors[i].enableInterrupt();
    
    sensors[i].setIntegrationTime(7000.0);
  
    sensors[i].setWaitTime(500.0);
   
    sensors[i].setGain(TCS3471_GAIN_1X);
   
    //sensors[i].interruptHighThreshold(32768);
   
    sensors[i].interruptLowThreshold(32767);
    
    sensors[i].interruptPersistence(2);
    
    sensors[i].clearInterrupt();
   
    sensors[i].enable();
  }

}
 
void displayData()
// dumps captured data from array to serial monitor
{
  Serial.println();
  Serial.println("Values from multiplexer:");
  Serial.println("========================");
  for (int i = 0; i < 1; i++)
  {
    Serial.print("input I"); 
    Serial.print(i); 
    Serial.print(" = "); 
    Serial.println(green[i]);
  }
  Serial.println("========================");   
}
 
void loop()
{
  //Serial.print("work");
  for (int i = 0; i < 5; i++)
  //int i=1;
  {Serial.println(i);
  
    tcaselect(i); // choose an input pin on the 74HC4067

    colorAvailable[i]=true;
    if (colorAvailable[i])
    {
     // Serial.print("yes");
      //Serial.println("");
    	if (sensors[i].rgbcValid())
    	{
    		// as mentioned previously, interrupt flag has to be cleared from host
    		sensors[i].clearInterrupt();
    		// reset Arduino flag too
    		colorAvailable[i] = false;
    		// read C(lear) channel data
    		// range from 0-65535
        	word clearVal = sensors[i].readCData();
        	// read R(ed) channel data
        	// range 0-65535
        	float c=clearVal;
        	word redVal   = sensors[i].readRData();
        	// read G(reen) channel data
        	// range 0-65535
        	float r=(redVal);
        	//r=r-498+255;
        	//Serial.print(redVal);
        	word greenVal = sensors[i].readGData();
        	float g=(greenVal);
        	//Serial.print(greenVal);
        	//g=g-242+255;
        	// read B(lue) channel data
        	// range 0-65535
        	
        	word blueVal  = sensors[i].readBData();
        	//Serial.print(blueVal);
        	float b=(blueVal);
        	//b=b-188+255;
        	// and print it all out
        	float avg=(c+r+g+b)/4;
        
        	r=r/avg;
        	b=b/avg;
        	g=g/avg;
        	clear[i]=c;
        	red[i]=r;
        	blue[i]=b;
        	green[i]=g;
        	
        	//Serial.print("Light is ");
        	//Serial.print(clearVal,DEC);
        	/*Serial.print(" overall and red is ");
        	Serial.print(r, DEC);
        	Serial.print(" while green is ");
        	Serial.print(g, DEC);
        	Serial.print(" and blue is ");
        	Serial.println(b, DEC);*/
        	
        	int x=RGB(i,r,g,b);
        	{
          	if(c<5000)
          	{
          	  Serial.print("key: ");
          	  Serial.println(i);
            	if (x==true){
            	Serial.print("Color: ");
            	Serial.println(colorcode[i]);
            	Serial.print("Finger: ");
            	Serial.println(finger[i]);
          	  }
          	  else 
          	  {
          	    Serial.print("Incorrect finger, please use ");
          	    Serial.println(finger[i]);
              }
          	
          	} 
        	  
        	} 
        	  
        }
      }
  }
  Serial.println("");
  delay(1000);
}
 

void TCS3471Int()
{
	colorAvailable[0] = true;
	colorAvailable[1] = true;
	colorAvailable[2] = true;
	colorAvailable[3] = true;
	colorAvailable[4] = true;
	colorAvailable[5] = true;
	colorAvailable[6] = true;
	colorAvailable[7] = true;
}

/*bool check_sensor(int i,int color){
  int detected=RGB(red[i],green[i],blue[i]);
  if (detected==color)
    {return true;}
  return false;
}*/

bool RGB(float c,float red,float green,float blue){
  if(c==0)
  {
  if ((red>0.7) & (red<1.05) & (green>0.44) & (green<0.6) & (blue>0.43) & (blue<0.6))
  {return true;}
  
  }
  
  if (c==1){
  if ((red>0.8) & (red<1.2) & (green>0.43) & (green<0.56) & (blue>0.42) & (blue<0.55))
  {return true;}
    
  }
  
  if(c==2){
  if ((red>1.3) & (red<1.9) & (green>0.12) & (green<0.30) & (blue>0.25) & (blue<0.45))
  {return true;}
    
  }
  
  if(c==3){
  if ((red>1.01) & (red<1.29) & (green>0.52) & (green<0.58) & (blue>0.42) & (blue<0.46))
  {return true;}
    
  }
  
  
  if(c==4){
   if ((red>1.3) & (red<1.64) & (green>0.22) & (green<0.30) & (blue>0.34) & (blue<0.5))
  {return true;}
    
  }
  
return false;
}

// implementation of i2cWrite and i2cRead functions for simplest 
//case when there is only one
// TCS2471 chip attached to Arduino's two wire bus
void i2cWrite(byte address, byte count, byte* buffer)
{
    Wire.beginTransmission(address);
    byte i;
    for (i = 0; i < count; i++)
    {
#if ARDUINO >= 100
        Wire.write(buffer[i]);
#else
        Wire.send(buffer[i]);
#endif
    }
    Wire.endTransmission();
}

void i2cRead(byte address, byte count, byte* buffer)
{
    Wire.requestFrom(address, count);
    byte i;
    for (i = 0; i < count; i++)
    {
#if ARDUINO >= 100
        buffer[i] = Wire.read();
#else
        buffer[i] = Wire.receive();
#endif
    }
}
